import { FunctionNode, ProgramRegisters, RawRegisters } from '../ast';

export interface Table<TEntry> {
  names: Array<[string, number]>;
  entries: Array<TEntry>;
}

export interface GlobalEntry {
  value: unknown;
}

export interface ProgramModule {
  functions: Table<FunctionNode>;
  globals: Table<GlobalEntry>;
  registers: Partial<RawRegisters>;
}

export type ProgramStack = Array<number>;

export interface Program {
  registers: ProgramRegisters;
  runtime: ProgramModule;
  program: ProgramModule;
  modules: Array<ProgramModule>;
  stack: ProgramStack;
}

export interface Codec {
  load: (source: string) => ProgramModule;
  save: (module: ProgramModule) => string;
}
