import { CommandNode, OpCode, ProgramRegisters } from '../../ast.js';
import { ProgramStack } from '../../module/index.js';
import { getValue } from '../register.js';
import { OpCodeFn, StepResult } from './base.js';

export const COMPARE_CODES: Partial<Record<OpCode, OpCodeFn>> = {
  [OpCode.COMPARE]: opCompare,
};

export function opCompare(instruction: CommandNode, registers: ProgramRegisters, stack: ProgramStack): StepResult {
  const a = getValue(registers, instruction.first);
  const b = getValue(registers, instruction.second);
  console.log('COMPARE', a, b);
  if (a !== b) {
    return {
      stop: false,
      step: 2,
    };
  } else {
    return {
      stop: false,
      step: 1,
    };
  }
}
