import { CommandNode, OpCode, ProgramRegisters } from '../../ast.js';
import { ProgramStack } from '../../module/index.js';
import { getRegister, setValue, getValue } from '../register.js';
import { OpCodeFn, StepResult } from './base.js';

export const MATH_CODES: Partial<Record<OpCode, OpCodeFn>> = {
  [OpCode.ADD]: opAdd,
};

export function opAdd(instruction: CommandNode, registers: ProgramRegisters, stack: ProgramStack): StepResult {
  const reg = getRegister(instruction.first);
  const val = (getValue(registers, instruction.second) + getValue(registers, instruction.third)) % Number.MAX_SAFE_INTEGER;
  console.log('ADD', reg, val);
  setValue(registers, reg, val);
  return {
    step: 1,
    stop: false,
  };
}

